#include <bits/stdc++.h>

using namespace std;

void die(const char msg[])
{
	// fprintf(stderr, "%s\n", msg);
	fprintf(stderr, "translate:wrong\n");
	printf("0\n");
	exit(1);
}

inline pair<int,int> read_edge(void) {
	int a, b;
	if (scanf("%d %d", &a, &b) != 2)
		die("Spatny format vystupu / prilis malo ulic");

	a--, b--;
	if (a > b)
		swap(a, b);
	return {a, b};
}

int main(int argc, char *argv[])
{
	if (argc != 4)
		return 2;
	char *arg_in = argv[1];
	char *arg_correct = argv[2];
	char *arg_tested = argv[3];

	freopen(arg_in, "r", stdin);

	int N, M, K;
	scanf("%d %d %d", &N, &M, &K);

	vector<pair<int, int>> important, unimportant;
	vector<int> deg(N);
	for (int i = 0; i < M; i++) {
		pair<int,int> e = read_edge();
		deg[e.first]++, deg[e.second]++;
		((i < K) ? important : unimportant).push_back(e);
	}

	sort(important.begin(), important.end());
	sort(unimportant.begin(), unimportant.end());
	vector<bool> used(unimportant.size());

	freopen(arg_correct, "r", stdin);
	bool possible = getchar() != '-';

	freopen(arg_tested, "r", stdin);
	int L;
	if (scanf("%d", &L) != 1)
		die("Spatny format vystupu");

	if (L < 0) {
		if (L == -1) {
			if (!possible) {
				fputs("translate:success\n", stderr);
				printf("1\n");
				return 0;
			} else {
				die("Program nenasel reseni, prestoze existuje");
			}
		}

		die("Spatny format vystupu");
	}

	for (int i = 0; i < L; i++) {
		pair<int,int> e = read_edge();
		if (binary_search(important.begin(), important.end(), e))
			die("Vystup obsahuje dulezitou ulici");

		auto it = lower_bound(unimportant.begin(), unimportant.end(), e);
		int ix = it - unimportant.begin();

		if (ix >= (int)unimportant.size() || unimportant[ix] != e)
			die("Vystup obsahuje neexistujici ulici");

		if (used[ix])
			die("Vystup obsahuje nejakou ulici dvakrat");

		deg[e.first]--, deg[e.second]--;
		used[ix] = true;
	}

	// TODO: ignorovat potenciální balast na konci účastníkova výstupu?
	
	for (int i = 0; i < N; i++)
		if (deg[i] % 2)
			die("Z nekterych krizovatek vede lichy pocet ulic");

	fputs("translate:success\n", stderr);
	printf("1\n");
	return 0;
}
