#include <bits/stdc++.h>

using namespace std;
int N, M, K;
vector<bool> odd;  // pro každý vrchol, zda s ním sousedí liše nezbořitelných cest
vector<vector<int>> G;     // pro každý vrchol seznamy id hran, které z něj vedou
vector<pair<int,int>> E;   // seznam všech nezbořitelných hran
vector<bool> keep;         // pro každou nedůležitou hranu, zda ji ponecháme
vector<bool> visited;      // zda jsme už vrchol navštívili v DFS

// vrchol na druhém konci dané hrany
inline int other(int e, int v)
{
    return (E[e].first == v) ? E[e].second : E[e].first;
}

// vrací, zda v podstromu vede nahoru hrana, kterou je potřeba spárovat
bool dfs(int v)
{
    assert(!visited[v]);
    visited[v] = true;
    for (auto e : G[v]) {
        int s = other(e, v);
        // pokud jsme vrchol ještě nenavštívili, spustíme DFS a podíváme se,
        // zda přebytek vyjde lichý (využíváme zkráceného vyhodnocování: pokud
        // už jsme vrchol navštívili, dfs(s) se neprovede)
        if (!visited[s] && dfs(s))
            odd[v] = !odd[v], keep[e] = true;
    }

    return odd[v];
}

int main(int argc, char *argv[])
{
    scanf("%d %d %d", &N, &M, &K);
    odd.resize(N);
    G.resize(N);
    visited.resize(N);
    keep.resize(M - K);

    for (int i = 0; i < M; i++) {
        int a, b;
        scanf("%d %d", &a, &b);
        a--, b--;
        if (i < K) {
            // Nezbořitelné hrany rovnou zahazujeme, jen podle nich
            // přepočítáváme parity ve vrcholech
            odd[a] = !odd[a], odd[b] = !odd[b];
        } else {
            E.push_back({a, b});
            G[a].push_back(i - K), G[b].push_back(i - K);
            // Posouváme id, aby první nedůležitá hrana měla id 0
        }
    }

    for (int i = 0; i < N; i++) {
        if (!visited[i] && dfs(i)) {
            // Na vrchol jsme pustili DFS a to nám vrátilo lichý přebytek, což
            // nutně znamená, že v komponentě je lichý počet lichých vrcholů
            printf("-1\n");
            return 0;
        }
    }

    int destroy = M - K;
    for (int e = 0; e < keep.size(); e++)
        destroy -= keep[e];

    printf("%d\n", destroy);
    for (int e = 0; e < keep.size(); e++)
        if (!keep[e])
            printf("%d %d\n", E[e].first + 1, E[e].second + 1);
}
